if [ -z $1 ] ; then
	echo  "Please provide the device to run the experiments."
	exit 1
fi

mkdir -p /root/workspace/out/synth_chains

for seed in 0 1 2
do  
    for split in fixed_2 fixed_3
    do
#         # Unstable
#         # --------
#         sed -i "s/\(.*name='\)[^']*\('.*\)/\1unstable-timing\2/" /root/workspace/stable-equiv/baselines/unstable_enflows/dw4.py
#         CUDA_VISIBLE_DEVICES=$1 python3 /root/workspace/stable-equiv/baselines/unstable_enflows/dw4.py \
#         setup.seed=$seed \
#         setup.device=cuda \
#         setup.sweep=True \
#         setup.train=True \
#         load.split=$split \
#         load.checkpoint_path=/root/workspace/out/unstable-timing-$split.pt \
#         train.epochs=300 \
#         train.patience=100 \
#         train.lr=5e-4 \
#         train.wd=1e-12 \
#         model.hidden_channels=32 \
#         model.hidden_layers=3 
#         sed -i "s/\(.*name='\)[^']*\('.*\)/\1unstable\2/" /root/workspace/stable-equiv/baselines/unstable_enflows/dw4.py

#         # Semistable
#         # ----------
        sed -i "s/\(.*name='\)[^']*\('.*\)/\1semistable-timing\2/" /root/workspace/stable-equiv/baselines/semistable_enflows/dw4.py
        CUDA_VISIBLE_DEVICES=$1 python3 /root/workspace/stable-equiv/baselines/semistable_enflows/dw4.py \
        setup.seed=$seed \
        setup.device=cuda \
        setup.sweep=True \
        setup.train=True \
        load.split=$split \
        load.checkpoint_path=/root/workspace/out/semistable-timing-$split.pt \
        train.epochs=100 \
        train.patience=100 \
        train.lr=5e-4 \
        train.wd=1e-12 \
        model.hidden_channels=32 \
        model.hidden_layers=3 
        sed -i "s/\(.*name='\)[^']*\('.*\)/\1semistable\2/" /root/workspace/stable-equiv/baselines/semistable_enflows/dw4.py
        
#         # Stable
#         # ------
        sed -i "s/\(.*name='\)[^']*\('.*\)/\1stable-timing\2/" /root/workspace/stable-equiv/stable_enf/dw4.py
        CUDA_VISIBLE_DEVICES=$1 python3 /root/workspace/stable-equiv/stable_enf/dw4.py \
        setup.seed=$seed \
        setup.device=cuda \
        setup.sweep=True \
        setup.train=True \
        load.split=$split \
        load.checkpoint_path=/root/workspace/out/stable-timing-$split.pt \
        train.epochs=100 \
        train.patience=100 \
        train.lr=5e-4 \
        train.wd=1e-12 \
        train.reg_weight=0.02 \
        train.remark='' \
        model.hidden_channels=32 \
        model.hidden_layers=3 \
        model.normalize=True \
        model.normalize_type=2 \
        model.reg_para=0 \
        model.ode_solver=2 \
        model.ode_mesh=2 \
        model.reg_clip=1e-16
        sed -i "s/\(.*name='\)[^']*\('.*\)/\1stable\2/" /root/workspace/stable-equiv/stable_enf/dw4.py
    done
done

# for seed in 0 1 2
# do  
#     for split in fixed_2, fixed_3
#     do
        # Unstable
        # --------
        # sed -i "s/\(.*name='\)[^']*\('.*\)/\1unstable-timing\2/" /root/workspace/stable-equiv/baselines/unstable_enflows/lj13.py
        # CUDA_VISIBLE_DEVICES=$1 python3 /root/workspace/stable-equiv/baselines/unstable_enflows/lj13.py \
        # setup.seed=$seed \
        # setup.device=cuda \
        # setup.sweep=True \
        # setup.train=True \
        # load.split=$split \
        # load.checkpoint_path=/root/workspace/out/unstable-timing-$split.pt \
        # train.epochs=300 \
        # train.patience=100 \
        # train.lr=5e-4 \
        # train.wd=1e-12 \
        # model.hidden_channels=32 \
        # model.hidden_layers=3 
        # sed -i "s/\(.*name='\)[^']*\('.*\)/\1unstable\2/" /root/workspace/stable-equiv/baselines/unstable_enflows/lj13.py

        # Semistable
        # ----------
        # sed -i "s/\(.*name='\)[^']*\('.*\)/\1semistable-timing\2/" /root/workspace/stable-equiv/baselines/semistable_enflows/lj13.py
        # CUDA_VISIBLE_DEVICES=$1 python3 /root/workspace/stable-equiv/baselines/semistable_enflows/lj13.py \
        # setup.seed=$seed \
        # setup.device=cuda \
        # setup.sweep=True \
        # setup.train=True \
        # load.split=$split \
        # load.checkpoint_path=/root/workspace/out/semistable-timing-$split.pt \
        # train.epochs=100 \
        # train.patience=100 \
        # train.lr=5e-4 \
        # train.wd=1e-12 \
        # model.hidden_channels=32 \
        # model.hidden_layers=3 
        # sed -i "s/\(.*name='\)[^']*\('.*\)/\1semistable\2/" /root/workspace/stable-equiv/baselines/semistable_enflows/lj13.py
        
        # Stable
        # ------
        # sed -i "s/\(.*name='\)[^']*\('.*\)/\1stable-timing\2/" /root/workspace/stable-equiv/stable_enf/lj13.py
        # CUDA_VISIBLE_DEVICES=$1 python3 /root/workspace/stable-equiv/stable_enf/lj13.py \
        # setup.seed=$seed \
        # setup.device=cuda \
        # setup.sweep=True \
        # setup.train=True \
        # load.split=$split \
        # load.checkpoint_path=/root/workspace/out/stable-timing-$split.pt \
        # train.epochs=100 \
        # train.patience=100 \
        # train.lr=5e-4 \
        # train.wd=1e-12 \
        # train.reg_weight=0.02 \
        # train.remark='' \
        # model.hidden_channels=32 \
        # model.hidden_layers=3 \
        # model.normalize=True \
        # model.normalize_type=2 \
        # model.reg_para=0 \
        # model.ode_solver=2 \
        # model.ode_mesh=2 \
        # model.reg_clip=1e-16
        # sed -i "s/\(.*name='\)[^']*\('.*\)/\1stable\2/" /root/workspace/stable-equiv/stable_enf/lj13.py
#     done
# done
